# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import SyncClientWrapper
from .raw_client import RawInternalClient
from .users.client import UsersClient
from .clusters.client import ClustersClient
from .deployments.client import DeploymentsClient
from .applications.client import ApplicationsClient
from .vcs.client import VcsClient
from .metrics.client import MetricsClient
from .artifact_versions.client import ArtifactVersionsClient
from ...core.client_wrapper import AsyncClientWrapper
from .raw_client import AsyncRawInternalClient
from .users.client import AsyncUsersClient
from .clusters.client import AsyncClustersClient
from .deployments.client import AsyncDeploymentsClient
from .applications.client import AsyncApplicationsClient
from .vcs.client import AsyncVcsClient
from .metrics.client import AsyncMetricsClient
from .artifact_versions.client import AsyncArtifactVersionsClient


class InternalClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawInternalClient(client_wrapper=client_wrapper)
        self.users = UsersClient(client_wrapper=client_wrapper)

        self.clusters = ClustersClient(client_wrapper=client_wrapper)

        self.deployments = DeploymentsClient(client_wrapper=client_wrapper)

        self.applications = ApplicationsClient(client_wrapper=client_wrapper)

        self.vcs = VcsClient(client_wrapper=client_wrapper)

        self.metrics = MetricsClient(client_wrapper=client_wrapper)

        self.artifact_versions = ArtifactVersionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawInternalClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawInternalClient
        """
        return self._raw_client


class AsyncInternalClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawInternalClient(client_wrapper=client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=client_wrapper)

        self.clusters = AsyncClustersClient(client_wrapper=client_wrapper)

        self.deployments = AsyncDeploymentsClient(client_wrapper=client_wrapper)

        self.applications = AsyncApplicationsClient(client_wrapper=client_wrapper)

        self.vcs = AsyncVcsClient(client_wrapper=client_wrapper)

        self.metrics = AsyncMetricsClient(client_wrapper=client_wrapper)

        self.artifact_versions = AsyncArtifactVersionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawInternalClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawInternalClient
        """
        return self._raw_client
